package CustomTags.DecoratorTag;
 
import java.lang.*;
import java.lang.reflect.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import CustomTags.*;
import Policy.*;
 
// Custom tag handler for bean property getter method.
public class GetProperty extends TagSupport {

  String _beanName;
  String _beanProperty;
  int _scope;

  public void setName(String name) {
    _beanName = name;
  }

  public void setProperty(String property) {
    _beanProperty = property;
  }

  public void setScope(String scope) {
    try {
      _scope = Utils.getScope( scope );
    } catch (Exception e) {
      System.out.print(e.getMessage());
    }
  }

  public int doStartTag () {
    try {
      // Get policy object.
      Policy policy = (Policy) pageContext.getAttribute("Policy", 
                                      PageContext.APPLICATION_SCOPE);
      // If this is the first time accessing policy object in this
      // application, create one and store in PageContext.
      if ( policy == null ) {
        String path = pageContext.getServletContext().getRealPath("/");
        policy = new Policy(path + "/WEB-INF/conf/PolicyConf.xml");
        pageContext.setAttribute("Policy", policy, 
                                 PageContext.APPLICATION_SCOPE);
      }

      Object beanObj = pageContext.getAttribute(_beanName, _scope);
      // Determine method name.
      String methodName = "get" +
                          _beanProperty.substring(0,1).toUpperCase() +
                          _beanProperty.substring(1);
      Class beanClass = beanObj.getClass();
      Method method = beanClass.getMethod(methodName, null);

      policy.execute(beanClass.getName(), method.getName(), 
                     "before", "log", null);
      // Call method through reflection.
      Object result = method.invoke(beanObj, null);
      policy.execute(beanClass.getName(), method.getName(), 
                     "after", "log", null);

      pageContext.getOut().print(result.toString());
    } catch (Exception e) {
      System.out.print(e.getMessage());
    }
    return SKIP_BODY;
  }

}
