package CustomTags.DynamicProxy;
 
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import CustomTags.*;
import Policy.*;
 
// Custom tag handler to initialize a JavaBean and its dynamic proxy.
public class UseBeanProxy extends TagSupport {

  String _beanName;
  String _beanClassName;
  int _scope;

  public void setId(String id) {
    _beanName = id;
  }

  public void setBeanClass(String beanClassName) {
    _beanClassName = beanClassName;
  }

  public void setScope(String scope) {
    try {
      _scope = Utils.getScope( scope );
    } catch (Exception e) {
      System.out.print(e.getMessage());
    }
  }

  public int doStartTag () {
    try {
      // If the named bean instance is already available, do nothing.
      if ( pageContext.getAttribute(_beanName, _scope) != null ) {
        return SKIP_BODY;
      }
      // Get policy object.
      Policy policy = (Policy) pageContext.getAttribute("Policy", 
                                     PageContext.APPLICATION_SCOPE);
      // If this is the first time accessing policy object in this
      // application, create one and store in PageContext.
      if ( policy == null ) {
        String path = pageContext.getServletContext().getRealPath("/");
        policy = new Policy(path + "/WEB-INF/conf/PolicyConf.xml");
        pageContext.setAttribute("Policy", policy, 
                                 PageContext.APPLICATION_SCOPE);
      }
      // Bean instance wrapped in a dynamic proxy.
      Object obj = BeanProxy.create( _beanClassName, policy );
      // Put the proxy instance into PageContext.
      pageContext.setAttribute(_beanName, obj, _scope);
    } catch (Exception e) {
      System.out.print(e.getMessage());
    }
    return SKIP_BODY;
  }

}
