package net.elucidsoft.encruft;

import java.lang.Exception;
import java.io.Serializable;
import javax.swing.table.AbstractTableModel;
import java.util.LinkedList;
import java.util.List;

/**
 *
 */
public class Document extends AbstractTableModel
{
  protected LinkedList m_list;

  public Document()
  {
    m_list      = new LinkedList(); 
  }
  // Abstract Table Model, implementation
  public int getRowCount()
  {
    return m_list.size();
  }

  public int getColumnCount()
  {
    return 1;
  }

  public Object getValueAt(int row, int col)
  {
    if(col !=0) {return null;}
    
    return m_list.get(row);
  }

  public void setValueAt(Object o, int row, int col)
  {
    //System.out.println("setValueAt("+o+","+row+","+col+")");
    if(col != 0)
    {
      throw new ArrayIndexOutOfBoundsException(
        "Document.setValueAt("+row+","+col+")");
    }
    m_list.set(row, o);
    fireTableCellUpdated(row,col);

  }

  public boolean isCellEditable(int row, int col)
  {
    return true;
  }
  
  public Object remove(int index)
  {
    if(index < 0) return null;

    //System.out.println("Document::remove("+index+")");
    Object o=m_list.remove(index);

    fireTableRowsDeleted(index, index);

    return o;
  }

  public void add(Object o)
  {
    m_list.add(o);
    fireTableRowsInserted(m_list.size()-1, m_list.size()-1);
  }

  public void setData(List data)
  {
    m_list = new LinkedList(data);
    fireTableDataChanged();
  }

  public List getData()
  {
    return (List)m_list;
  }
}
